import datetime
import pkg_resources
from pyramid.response import FileResponse
from sqlalchemy.orm import joinedload_all
from sqlalchemy.sql.expression import func, or_, and_
import uuid

from pyramid.view import view_config
import transaction

from brewman.models import DBSession
from brewman.models.master import LedgerBase
from brewman.models.validation_exception import TryCatchFunction

from brewman.models.voucher import Voucher, Journal, VoucherType
from brewman.views.services.session import session_period_start, session_period_finish
from brewman.views.services.voucher import get_edit_url


@view_config(request_method='GET', route_name='reconcile_id', permission='Reconcile')
@view_config(request_method='GET', route_name='reconcile', permission='Reconcile')
def html(request):
    package, resource = 'brewman:static/base.html'.split(':', 1)
    file = pkg_resources.resource_filename(package, resource)
    return FileResponse(file, request=request)


@view_config(request_method='GET', route_name='api_reconcile', renderer='json', permission='Reconcile')
def show_blank(request):
    return {'StartDate': session_period_start(request),
            'FinishDate': session_period_finish(request), 'Ledger': None, 'Body': []}


@view_config(request_method='GET', route_name='api_reconcile_id', renderer='json', permission='Reconcile')
@TryCatchFunction
def show_data(request):
    id = request.matchdict['id']
    account = LedgerBase.by_id(uuid.UUID(id))
    start_date = request.GET.get('StartDate', session_period_start(request))
    finish_date = request.GET.get('FinishDate', session_period_finish(request))
    info = {'StartDate': start_date, 'FinishDate': finish_date,
            'Account': {'LedgerID': account.id, 'Name': account.name}, 'Body': []}
    build_report(request, info)
    return info


def build_report(request, info):
    ledger_id = info['Account']['LedgerID']
    start_date = info['StartDate']
    finish_date = info['FinishDate']
    opening = opening_balance(ledger_id, start_date)
    info['Body'].append(opening)

    query = Voucher.query().options(
        joinedload_all(Voucher.journals, Journal.ledger, innerjoin=True)
    ).filter(
        Voucher.journals.any(Journal.ledger_id == ledger_id)
    ).filter(
        or_(
            Voucher.is_reconciled == False,
            and_(
                Voucher.reconcile_date >= datetime.datetime.strptime(start_date, '%d-%b-%Y'),
                Voucher.reconcile_date <= datetime.datetime.strptime(finish_date, '%d-%b-%Y')
            )
        )
    ).filter(
        Voucher.type != VoucherType.by_name('Issue').id
    ).order_by(Voucher.is_reconciled).order_by(Voucher.reconcile_date).order_by(Voucher.last_edit_date).all()

    for voucher in query:
        debit = 0
        credit = 0
        journal_debit = 0
        name = ""
        for journal in voucher.journals:
            if journal.ledger_id == ledger_id:
                journal_debit = journal.debit
                if journal.debit == 1:
                    debit = journal.amount
                    credit = 0
                else:
                    credit = journal.amount
                    debit = 0
        for journal in voucher.journals:
            if journal.debit != journal_debit:
                name += "{0} / ".format(journal.ledger.name)
        name = name[:-3]
        info['Body'].append(
            {'VoucherID': voucher.id, 'Date': voucher.date.strftime('%d-%b-%Y'), 'Name': name,
             'Url': get_edit_url(request, voucher), 'Type': VoucherType.by_id(voucher.type).name,
             'Narration': voucher.narration, 'Debit': debit, 'Credit': credit, 'IsReconciled': voucher.is_reconciled,
             'ReconcileDate': voucher.reconcile_date.strftime('%d-%b-%Y')})


def opening_balance(ledgerID, start_date):
    opening = DBSession.query(func.sum(Journal.amount * Journal.debit)) \
        .join(Journal.voucher) \
        .filter(Voucher.reconcile_date < datetime.datetime.strptime(start_date, '%d-%b-%Y')) \
        .filter(Voucher.is_reconciled == True) \
        .filter(Voucher.type != VoucherType.by_name('Issue').id) \
        .filter(Journal.ledger_id == ledgerID) \
        .scalar()
    opening = 0 if opening is None else opening
    if opening < 0:
        credit = opening * -1
        debit = 0
    else:
        debit = opening
        credit = 0
    return {'Date': start_date, 'ID': 'OB', 'Name': 'Opening Balance', 'Type': 'Opening Balance', 'Narration': '',
            'Debit': debit, 'Credit': credit, 'Running': opening, 'IsReconciled': True, 'ReconcileDate': start_date}


@view_config(request_method='POST', route_name='api_reconcile_id', renderer='json', permission='Reconcile')
def save(request):
    id = request.matchdict['id']
    account = LedgerBase.by_id(uuid.UUID(id))
    start_date = request.GET.get('StartDate', session_period_start(request))
    finish_date = request.GET.get('FinishDate', session_period_finish(request))
    for item in request.json_body['Body']:
        if 'VoucherID' not in item:
            continue
        voucher = Voucher.by_id(uuid.UUID(item['VoucherID']))
        is_reconciled = item['IsReconciled']
        reconcile_date = datetime.datetime.strptime(item['ReconcileDate'], '%d-%b-%Y')
        voucher.is_reconciled = is_reconciled
        voucher.reconcile_date = reconcile_date
    transaction.commit()

    info = {'StartDate': start_date, 'FinishDate': finish_date,
            'Account': {'LedgerID': account.id, 'Name': account.name},
            'Body': [], 'Footer': {}}
    build_report(request, info)
    return info
